//You can include any C libraries that you normally use
#include "math.h"
#include "mex.h"   //--This one is required

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	//Declarations
	// INPUT
	mxArray *xLP;		// Legendre polys
	mxArray *dJK;	// expansion
	mxArray *ord;	// PSWF max order
	int Ord;
	// OUTPUT
	double *xPS;  // PSWF
	// INTERN
	double *xlp, *djk;
	int xLen, ordLP, ordPS, i, j, k;
	
	//Copy input pointers
	xLP = prhs[0]; 
	dJK = prhs[1];
	ord = prhs[2];
	
	//Get input
	xlp = mxGetPr(xLP);		// legendre
	xLen = mxGetM(xLP);	// x length
	//xLen = mxGetN(xLP);	// x length
	djk = mxGetPr(dJK);		// exp coefs pswf
	ordLP = mxGetM(dJK);	// legendre max order
	ordPS = (int)(mxGetScalar(ord)); // PSWF max order
	
	//Allocate memory and assign output pointer
	plhs[0] = mxCreateDoubleMatrix(xLen, ordPS, mxREAL); //mxReal is our data-type
	//plhs[0] = mxCreateDoubleMatrix(ordPS, xLen, mxREAL); //mxReal is our data-type
	
	//Get a pointer to the data space in our newly allocated memory
	xPS = mxGetPr(plhs[0]);

	// initialize PSWF
	for(i=0;i<ordPS;i++) // LOOP PSWF ORDER
	{
		for(j=0;j<xLen;j++) // LOOP COORDINATE
		{
			xPS[(i*xLen)+j] = 0.0;
		}
	}
	
	// compute PSWF
	for(i=0;i<ordPS;i++) // LOOP PSWF ORDER
	{
		for(k=0;k<ordLP;k++) // LOOP LEGENDRE ORDER
		{
			//xPS[(j*ordPS)+i] = 0.0;
			for(j=0;j<xLen;j++) // LOOP COORDINATE
			{
				//xlp[(k*xLen)+j]*djk[(k*ordLP)+i];
				//xPS[(j*ordPS)+i] = xPS[(j*ordPS)+i] + xlp[(j*ordLP)+k]*djk[(i*ordLP)+k];
				
				//xPS[(j*ordPS)+i] = xPS[(j*ordPS)+i] + xlp[(k*xLen)+j]*djk[(k*ordLP)+i];
				//xPS[(j*ordPS)+i] = xPS[(j*ordPS)+i] + xlp[(k*xLen)+j]*djk[(i*ordLP)+k];
				xPS[(i*xLen)+j] = xPS[(i*xLen)+j] +  xlp[(k*xLen)+j]*djk[(i*ordLP)+k];
			}
		}
	}	
	return;
}