//You can include any C libraries that you normally use
#include "math.h"
#include "mex.h"   //--This one is required

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
//Declarations
mxArray *xData;		// x positions
mxArray *zData;		// order
double *xValues, *outArray;
int Ord, rowLen, colLen, i, j;

//Copy input pointer x
xData = prhs[0];
zData = prhs[1];

//Get matrix x
xValues = mxGetPr(xData);
rowLen = mxGetN(xData);
colLen = mxGetM(xData);

Ord = (int)(mxGetScalar(zData));

//Allocate memory and assign output pointer
plhs[0] = mxCreateDoubleMatrix(colLen, Ord, mxREAL); //mxReal is our data-type

//Get a pointer to the data space in our newly allocated memory
outArray = mxGetPr(plhs[0]);

// compute Legendre poly vals
for(i=0;i<Ord;i++)
{
    for(j=0;j<colLen;j++)
    {
        if(i==0)
		{
		outArray[(i*colLen)+j] = (double)1;
		}
		else if(i==1)
		{
		outArray[(i*colLen)+j] = xValues[j];	
		}
		else
		{
			outArray[(i*colLen)+j] = -((double)i-1)/(double)i*outArray[(int)((i-2)*colLen)+j] + (2*(double)i-1)/(double)i*xValues[j]*outArray[(int)((i-1)*colLen)+j];
		}
    }
}

//  normalize Legendre polys
	for(i=0;i<Ord;i++)
	{
		for(j=0;j<colLen;j++)
		{
			outArray[(i*colLen)+j] = outArray[(i*colLen)+j] *sqrt( i + 0.5);
		}
	}	
return;
}