function [XX,YY,IND] = reg_inpoly_ind(xypol,xg,yg)
%% function [XX,YY,IND] = reg_inpoly_ind(xypol,xg,yg)
% create points within border xypol lying on grid (xg,yg) and corresponding
% index

[a,b]=size(xypol); if b>a; xypol=xypol'; end
x1=xypol(:,1); y1=xypol(:,2);

x1=x1(:);
y1=y1(:);

dx=diff(xg(1:2));
dy=diff(yg(1:2));
x00=mean(x1);y00=mean(y1);
x0=xg(1); y0=yg(1);
% slightly enlarge borders
ddg=dx/50; x1=(x1-x00)*(1+ddg)+x00;y1=(y1-y00)*(1+ddg)+y00;
x1=x1-x0; y1=y1-y0;
xg=xg-x0; yg=yg-y0;

% calculate line segments (normals/intersects)
px=[x1(1:end-1) x1(2:end)]; dpx=diff(px,1,2);   ny=dpx;
py=[y1(1:end-1) y1(2:end)]; dpy=diff(py,1,2);   nx=-dpy;
is=-nx.*px(:,1)-ny.*py(:,1);
ym=min(py,[],2); yM=max(py,[],2);

% tag if points are starting or stopping points on regular grid
stoptag=dpy<0;starttag=dpy>0;

XX=[]; YY=[];
warning off
% step through second coordinate
LYG=length(yg);
for k=1:LYG;
    lineid=find((ym<=yg(k))&(yM>=yg(k)));
    xgk=(ceil(-(is(lineid)+ny(lineid)*yg(k))./nx(lineid)/dx)-stoptag(lineid))*dx;
    % eliminate duplicate elements
    dxgk=[1; 1+find(diff(sort(xgk)))];
    if ~isempty(xgk)
        xgk=xgk(dxgk);
        [xgk,sid]=sort(xgk);
        lineid=lineid(sid);
        if numel(lineid)
            id1=find(starttag(lineid));
            id2=find(stoptag(lineid));
            while numel(id1)>numel(id2); id1=id1(1:end-1); end
            while numel(id2)>numel(id1); id2=id2(2:end); end
            for m=1:length(id1);
                xtmp=xgk(id1(m)):dx:xgk(id2(m));
                ytmp=ones(size(xtmp))*yg(k);
                XX=[XX xtmp];
                YY=[YY ytmp];
            end
            
        end
    end
end

Nx=length(xg); Ny=length(yg);

xid=round((XX)/dx)+1;
yid=round((YY)/dy)+1;

XX=XX+x0;
YY=YY+y0;



% keyboard

IND=sub2ind([Ny,Nx],yid,xid);

[IND,id]=unique(IND);
XX=XX(id);YY=YY(id);


warning on;
