function w=dpwave_window(eta1,eta2,k1_high,N_nu,type);
r=sqrt(eta1.^2+eta2.^2);
theta=atan2(eta2,eta1);

if (N_nu>2)
  tlen=pi/N_nu;
else tlen=pi/8; end;

% wt=cos(apol(abs(theta/(2*tlen)),9)*pi/2).*(abs(theta)<=tlen*2);
angle_neighbors=N_nu+1;
theta_j=r/k1_high.*theta;
wt=cos(apol(abs(theta_j/(2*tlen)),9)*pi/2).^2.*(abs(theta_j)<=tlen*2);
wt_rep=0*wt;
for j=-(angle_neighbors-1)/2:(angle_neighbors-1)/2;
  theta_j=r/k1_high.*(theta+2*tlen*j);
  wt_rep=wt_rep+cos(apol(abs(theta_j/(2*tlen)),9)*pi/2).^2.*(abs(theta_j)<=tlen*2);
end;
wt=sqrt(wt./(wt_rep+1e-32));

wr=w_meyer(2*r/k1_high,type,9);

if (N_nu>2),
  w=wt.*wr;
else
  w=wr;
end;

%Subfunction
function y=w_meyer(x,type,deg)
switch lower(type)
  case {'detail'}
    L = sin(pi/2*apol(2*x-1,deg));
    R = cos(pi/2*apol(x-1,deg));
    y=(x>=1/2).*(x<1).*L+(x>=1).*(x<=2).*R;
  case {'coarse'}
    t=abs(x);
    y = cos(pi/2*apol(2*t-1,deg));
  case {'fine'}
    L = sin(pi/2*apol(2*x-1,deg));
    y=(x>=1/2).*(x<1).*L+(x>=1).*(x<=2)+(x>2);
end;

function y=apol(t,deg);
if nargin<2,
  deg=4;
end;
if deg>10,
  n=2*(deg+1);
  a=ones(1,n);A=zeros(n,n);
  for j=0:n/2-1,
    A(j+1,1:n-j)=a;
    a=polyder(a);
  end;
  for j=0:n/2-1,
    A(j+1+n/2,n-j)=A(j+1,n-j);
  end;
  tar=zeros(size(A,1),1);tar(1)=1;
  Asym=sym(A(:,1:deg+1));
  p=double(Asym\tar);
else
  P=[     -2           6         -20          70        -252         924       -3432       12870      -48620      184756;
           3         -15          70        -315        1386       -6006       25740     -109395      461890    -1939938;
           0          10         -84         540       -3080       16380      -83160      408408    -1956240     9189180;
           0           0          35        -420        3465      -24024      150150     -875160     4849845   -25865840;
           0           0           0         126       -1980       20020     -163800     1178100    -7759752    47927880;
           0           0           0           0         462       -9009      108108    -1021020     8314020   -61108047;
           0           0           0           0           0        1716      -40040      556920    -5969040    54318264;
           0           0           0           0           0           0        6435     -175032     2771340   -33256080;
           0           0           0           0           0           0           0       24310     -755820    13430340;
           0           0           0           0           0           0           0           0       92378    -3233230;
           0           0           0           0           0           0           0           0           0      352716];
  p=P(1:deg+1,deg);
end;
y = t.^(deg+1).*polyval(p,t).*(t>0).*(t<=1)+(t>1);   


  