function [nu,xi,tt] = xi_k_nupp(conf,K,the_NU,Norm);

cflag=strcmp(conf.cplx_flag,'complex');

% orientation (physical units)
tt=conf.theta{K}(the_NU);
xi1c = conf.xi1_0{K}{the_NU}; xi2c = conf.xi2_0{K}{the_NU};
xi11bis=sqrt(xi1c^2+xi2c^2);
xi1cn=xi11bis*cos(tt)*Norm(1); xi2cn=-xi11bis*sin(tt)*Norm(2);
nu(1)=xi1cn./sqrt(xi1cn.^2+xi2cn.^2);
nu(2)=xi2cn./sqrt(xi1cn.^2+xi2cn.^2);
tt=acos(xi1cn./sqrt(xi1cn.^2+xi2cn.^2));

% read xi box grid
if K==1;
    bc=1;
else
    if cflag;OFFSET=1+sum(conf.N_nu(2:K-1));else;OFFSET=1+sum(conf.N_nu(2:K-1))/2;end
    bc=OFFSET+the_NU;
end

% normalized frequencies for USFFT
xi{1}=-conf.xi1(conf.boxidx(bc,1):conf.boxidx(bc,2));
xi{2}=-conf.xi2(conf.boxidx(bc,1):conf.boxidx(bc,2));






