function [IMAGE] = stick_imagepp(IMAGE)
%% function [IMAGE] = stick_imagepp(IMAGE)
% gather box contributions and add them up to one image


% get rid of empty matrix elements
[a,MNnu]=size(IMAGE.idy1min);
for kid=1:length(IMAGE.PART)
    Nnu=length(IMAGE.PART{kid});
    if Nnu<MNnu
        IMAGE.y1_1(kid, Nnu+1:MNnu)=NaN;
        IMAGE.y1_2(kid, Nnu+1:MNnu)=NaN;
        IMAGE.y2_1(kid, Nnu+1:MNnu)=NaN;
        IMAGE.y2_2(kid, Nnu+1:MNnu)=NaN;
        IMAGE.idy1min(kid, Nnu+1:MNnu)=NaN;
        IMAGE.idy2min(kid, Nnu+1:MNnu)=NaN;
        IMAGE.idy1max(kid, Nnu+1:MNnu)=NaN;
        IMAGE.idy2max(kid, Nnu+1:MNnu)=NaN;
    end
end

% calculate dimension of finalimage
IMAGE.fully1=[min(IMAGE.y1_1(:)) max(IMAGE.y1_2(:))];
IMAGE.fully2=[min(IMAGE.y2_1(:)) max(IMAGE.y2_2(:))];

idy1min=min([IMAGE.idy1min(:)]);
idy2min=min([IMAGE.idy2min(:)]);
idy1max=max([IMAGE.idy1max(:)]);
idy2max=max([IMAGE.idy2max(:)]);

N1all=max(IMAGE.idy1min(:)+IMAGE.N1(:)-idy1min);
N2all=max(IMAGE.idy2min(:)+IMAGE.N2(:)-idy2min);

idy11=IMAGE.idy1min-idy1min;
idy12=IMAGE.idy1max-idy1min;
idy21=IMAGE.idy2min-idy2min;
idy22=IMAGE.idy2max-idy2min;

% add up contributions
TMPIM=zeros(N1all,N2all);
for kid=1:length(IMAGE.PART)
    for nuid=1:length(IMAGE.PART{kid})
        partim=IMAGE.PART{kid}{nuid};
        n1=IMAGE.N1(kid,nuid); n2=IMAGE.N2(kid,nuid); 
        i11=idy11(kid,nuid); i12=idy12(kid,nuid);
        i21=idy21(kid,nuid); i22=idy22(kid,nuid);
        if i11<i12;
            i12=i11+n1; i11=i11+1; 
        else
            i11=i12+1; i12=i12+n1;
        end
        if i21<i22;
            i22=i21+n2; i21=i21+1;
        else
            i21=i22+1; i22=i22+n2;
        end
        TMPIM(i11:i12,i21:i22)=TMPIM(i11:i12,i21:i22)+partim;
    end
end
IMAGE.FULL=TMPIM;
IMAGE.N_FULL=size(IMAGE.FULL);
